## shim 15.8

=== Makefile ===
default : all

NAME		= shim
VERSION		= 15.8
ifneq ($(origin RELEASE),undefined)
DASHRELEASE	?= -$(RELEASE)
else
DASHRELEASE	?=
endif

ifeq ($(MAKELEVEL),0)
TOPDIR		?= $(shell pwd)
endif
ifeq ($(TOPDIR),)
override TOPDIR := $(shell pwd)
endif
override TOPDIR	:= $(abspath $(TOPDIR))
VPATH		= $(TOPDIR)
export TOPDIR

include $(TOPDIR)/Make.rules
include $(TOPDIR)/Make.defaults
include $(TOPDIR)/include/coverity.mk
include $(TOPDIR)/include/scan-build.mk
include $(TOPDIR)/include/fanalyzer.mk

TARGETS	= $(SHIMNAME)
TARGETS += $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
TARGETS += $(SHIMHASHNAME)
endif
ifneq ($(origin ENABLE_SHIM_DEVEL),undefined)
CFLAGS += -DENABLE_SHIM_DEVEL
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
TARGETS	+= $(MMNAME).signed $(FBNAME).signed
CFLAGS += -DENABLE_SHIM_CERT
else
TARGETS += $(MMNAME) $(FBNAME)
endif
OBJS	= shim.o globals.o mok.o netboot.o cert.o replacements.o tpm.o version.o errlog.o sbat.o sbat_data.o sbat_var.o pe.o pe-relocate.o httpboot.o csv.o load-options.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
ORIG_SOURCES	= shim.c globals.c mok.c netboot.c replacements.c tpm.c errlog.c sbat.c pe.c pe-relocate.c httpboot.c shim.h version.h $(wildcard include/*.h) cert.S sbat_var.S
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o errlog.o sbat_data.o globals.o
ORIG_MOK_SOURCES = MokManager.c PasswordCrypt.c crypt_blowfish.c shim.h $(wildcard include/*.h)
FALLBACK_OBJS = fallback.o tpm.o errlog.o sbat_data.o globals.o
ORIG_FALLBACK_SRCS = fallback.c
SBATPATH = $(TOPDIR)/data/sbat.csv

ifeq ($(SOURCE_DATE_EPOCH),)
	UNAME=$(shell uname -s -m -p -i -o)
else
	UNAME=buildhost
endif

SOURCES = $(foreach source,$(ORIG_SOURCES),$(TOPDIR)/$(source)) version.c
MOK_SOURCES = $(foreach source,$(ORIG_MOK_SOURCES),$(TOPDIR)/$(source))
FALLBACK_SRCS = $(foreach source,$(ORIG_FALLBACK_SRCS),$(TOPDIR)/$(source))

ifneq ($(origin FALLBACK_VERBOSE), undefined)
	CFLAGS += -DFALLBACK_VERBOSE
endif

ifneq ($(origin FALLBACK_NONINTERACTIVE), undefined)
	CFLAGS += -DFALLBACK_NONINTERACTIVE
endif

ifneq ($(origin FALLBACK_VERBOSE_WAIT), undefined)
	CFLAGS += -DFALLBACK_VERBOSE_WAIT=$(FALLBACK_VERBOSE_WAIT)
endif

all: confcheck $(TARGETS)

confcheck:
ifneq ($(origin EFI_PATH),undefined)
	$(error EFI_PATH is no longer supported, you must build using the supplied copy of gnu-efi)
endif

compile_commands.json : Makefile Make.rules Make.defaults 
	make clean
	bear -- make COMPILER=clang test all
	sed -i \
		-e 's/"-maccumulate-outgoing-args",//g' \
		$@

update :
	git submodule update --init --recursive

shim.crt:
	$(TOPDIR)/make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	$(OPENSSL) x509 -outform der -in $< -out $@

.NOTPARALLEL: shim_cert.h
shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] __attribute__((__unused__)) = {" > $@
	$(HEXDUMP) -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : $(TOPDIR)/version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(UNAME)," \
		-e "s,@@COMMIT@@,$(COMMIT_ID)," \
		< $< > $@

certdb/secmod.db: shim.crt
	-mkdir certdb
	$(PK12UTIL) -d certdb/ -i shim.p12 -W "" -K ""
	$(CERTUTIL) -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES)
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
shim.o: shim_cert.h
endif
shim.o: $(wildcard $(TOPDIR)/*.h)

sbat.%.csv : data/sbat.%.csv
	$(DOS2UNIX) $(D2UFLAGS) $< $@
	tail -c1 $@ | read -r _ || echo >> $@ # ensure a trailing newline

VENDOR_SBATS := $(sort $(foreach x,$(wildcard $(TOPDIR)/data/sbat.*.csv data/sbat.*.csv),$(notdir $(x))))

sbat_data.o : | $(SBATPATH) $(VENDOR_SBATS)
sbat_data.o : /dev/null
	$(CC) $(CFLAGS) -x c -c -o $@ $<
	$(OBJCOPY) --add-section .sbat=$(SBATPATH) \
		--set-section-flags .sbat=contents,alloc,load,readonly,data \
		$@
	$(foreach vs,$(VENDOR_SBATS),$(call add-vendor-sbat,$(vs),$@))

$(SHIMNAME) : $(SHIMSONAME) post-process-pe
$(MMNAME) : $(MMSONAME) post-process-pe
$(FBNAME) : $(FBSONAME) post-process-pe
$(SHIMNAME) $(MMNAME) $(FBNAME) : | post-process-pe

LIBS = Cryptlib/libcryptlib.a \
       Cryptlib/OpenSSL/libopenssl.a \
       lib/lib.a \
       gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a \
       gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a

$(SHIMSONAME): $(OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

fallback.o: $(FALLBACK_SRCS)

$(FBSONAME): $(FALLBACK_OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

MokManager.o: $(MOK_SOURCES)

$(MMSONAME): $(MOK_OBJS) $(LIBS)
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a: CFLAGS+=-DGNU_EFI_USE_EXTERNAL_STDARG
gnu-efi/$(ARCH_GNUEFI)/gnuefi/libgnuefi.a gnu-efi/$(ARCH_GNUEFI)/lib/libefi.a:
	mkdir -p gnu-efi/lib gnu-efi/gnuefi
	$(MAKE) -C gnu-efi \
		COMPILER="$(COMPILER)" \
		CCC_CC="$(COMPILER)" \
		CC="$(CC)" \
		ARCH=$(ARCH_GNUEFI) \
		TOPDIR=$(TOPDIR)/gnu-efi \
		-f $(TOPDIR)/gnu-efi/Makefile \
		lib gnuefi inc $(IGNORE_COMPILER_ERRORS)

Cryptlib/libcryptlib.a:
	for i in Hash Hmac Cipher Rand Pk Pem SysCall; do mkdir -p Cryptlib/$$i; done
	$(MAKE) TOPDIR=$(TOPDIR) VPATH=$(TOPDIR)/Cryptlib -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile $(IGNORE_COMPILER_ERRORS)

Cryptlib/OpenSSL/libopenssl.a:
	for i in x509v3 x509 txt_db stack sha rsa rc4 rand pkcs7 pkcs12 pem ocsp objects modes md5 lhash kdf hmac evp err dso dh conf comp cmac buffer bn bio async/arch asn1 aes; do mkdir -p Cryptlib/OpenSSL/crypto/$$i; done
	$(MAKE) TOPDIR=$(TOPDIR) VPATH=$(TOPDIR)/Cryptlib/OpenSSL -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile $(IGNORE_COMPILER_ERRORS)

lib/lib.a: | $(TOPDIR)/lib/Makefile $(wildcard $(TOPDIR)/include/*.[ch])
	mkdir -p lib
	$(MAKE) VPATH=$(TOPDIR)/lib TOPDIR=$(TOPDIR) -C lib -f $(TOPDIR)/lib/Makefile $(IGNORE_COMPILER_ERRORS)

post-process-pe : $(TOPDIR)/post-process-pe.c
	$(HOSTCC) -std=gnu11 -Og -g3 -Wall -Wextra -Wno-missing-field-initializers -Werror -o $@ $<

buildid : $(TOPDIR)/buildid.c
	$(HOSTCC) -I/usr/include -Og -g3 -Wall -Werror -Wextra -o $@ $< -lelf

$(BOOTCSVNAME) :
	@echo Making $@
	@echo "$(SHIMNAME),$(OSLABEL),,This is the boot entry for $(OSLABEL)" | iconv -t UCS-2LE > $@

install-check :
ifeq ($(origin LIBDIR),undefined)
	$(error Architecture $(ARCH) is not a supported build target.)
endif
ifeq ($(origin EFIDIR),undefined)
	$(error EFIDIR must be set to your reserved EFI System Partition subdirectory name)
endif

install-deps : $(TARGETS)
install-deps : $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug buildid
install-deps : $(BOOTCSVNAME)

install-debugsource : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)
	find $(TOPDIR) -type f -a '(' -iname '*.c' -o -iname '*.h' -o -iname '*.S' ')' | while read file ; do \
		outfile=$$(echo $${file} | sed -e "s,^$(TOPDIR),,") ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$$(dirname $${outfile}) ; \
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$${outfile} ; \
	done

install-debuginfo : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR)/
	@./buildid $(wildcard *.efi.debug) | while read file buildid ; do \
		first=$$(echo $${buildid} | cut -b -2) ; \
		rest=$$(echo $${buildid} | cut -b 3-) ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/ ;\
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR) ; \
		ln -s ../../../../..$(DEBUGINFO)$(TARGETDIR)$${file} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest}.debug ;\
		ln -s ../../../.build-id/$${first}/$${rest} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest} ;\
	done

install : | install-check
install : install-deps install-debuginfo install-debugsource
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0700 $(DESTDIR)/$(ESPROOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(EFIBOOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(TARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(EFIBOOTDIR)/$(BOOTEFINAME)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(TARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(TARGETDIR)/
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(FBNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(TARGETDIR)/$(MMNAME)
else
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(TARGETDIR)/
endif

install-as-data : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DATATARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(DATATARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(DATATARGETDIR)/
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
	$(INSTALL) -m 0644 $(SHIMHASHNAME) $(DESTDIR)/$(DATATARGETDIR)/
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
else
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
endif

%.efi: %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data -j .data.ident \
		-j .dynamic -j .rodata -j .rel* \
		-j .rela* -j .dyn -j .reloc -j .eh_frame \
		-j .vendor_cert -j .sbat -j .sbatlevel \
		$(FORMAT) $< $@
	./post-process-pe -vv $(POST_PROCESS_PE_FLAGS) $@

ifneq ($(origin ENABLE_SHIM_HASH),undefined)
%.hash : %.efi
	$(PESIGN) -i $< -P -h > $@
endif

%.efi.debug : %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data \
		-j .dynamic -j .rodata -j .rel* \
		-j .rela* -j .dyn -j .reloc -j .eh_frame -j .sbat \
		-j .sbatlevel \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		-j .note.gnu.build-id \
		$< $@

ifneq ($(origin ENABLE_SBSIGN),undefined)
%.efi.signed: %.efi shim.key shim.crt
	@$(SBSIGN) \
		--key shim.key \
		--cert shim.crt \
		--output $@ $<
else
%.efi.signed: %.efi certdb/secmod.db
	$(PESIGN) -n certdb -i $< -c "shim" -s -o $@ -f
endif

fuzz fuzz-clean fuzz-coverage fuzz-lto :
	@make -f $(TOPDIR)/include/fuzz.mk \
		COMPILER="$(COMPILER)" \
		CROSS_COMPILE="$(CROSS_COMPILE)" \
		CLANG_WARNINGS="$(CLANG_WARNINGS)" \
		ARCH_DEFINES="$(ARCH_DEFINES)" \
		EFI_INCLUDES="$(EFI_INCLUDES)" \
		fuzz-clean $@

test test-clean test-coverage test-lto :
	@make -f $(TOPDIR)/include/test.mk \
		COMPILER="$(COMPILER)" \
		CROSS_COMPILE="$(CROSS_COMPILE)" \
		CLANG_WARNINGS="$(CLANG_WARNINGS)" \
		ARCH_DEFINES="$(ARCH_DEFINES)" \
		EFI_INCLUDES="$(EFI_INCLUDES)" \
		test-clean $@

$(patsubst %.c,%,$(wildcard fuzz-*.c)) :
	@make -f $(TOPDIR)/include/fuzz.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" $@

$(patsubst %.c,%,$(wildcard test-*.c)) :
	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" $@

clean-fuzz-objs:
	@make -f $(TOPDIR)/include/fuzz.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" clean

clean-test-objs:
	@make -f $(TOPDIR)/include/test.mk EFI_INCLUDES="$(EFI_INCLUDES)" ARCH_DEFINES="$(ARCH_DEFINES)" clean

.PHONY : $(patsubst %.c,%,$(wildcard fuzz-*.c)) fuzz
.PHONY : $(patsubst %.c,%,$(wildcard test-*.c)) test

clean-gnu-efi:
	@if [ -d gnu-efi ] ; then \
		$(MAKE) -C gnu-efi \
			CC="$(CC)" \
			HOSTCC="$(HOSTCC)" \
			COMPILER="$(COMPILER)" \
			ARCH=$(ARCH_GNUEFI) \
			TOPDIR=$(TOPDIR)/gnu-efi \
			-f $(TOPDIR)/gnu-efi/Makefile \
			clean ; \
	fi

clean-lib-objs:
	@if [ -d lib ] ; then \
		$(MAKE) -C lib TOPDIR=$(TOPDIR) -f $(TOPDIR)/lib/Makefile clean ; \
	fi

clean-shim-objs:

=== Cryptlib/Makefile ===
ifneq ($(CCACHE_DISABLE),)
export CCACHE_DISABLE
endif

CRYPTDIR	= $(TOPDIR)/Cryptlib

FEATUREFLAGS	+= -nostdinc

INCLUDES	= -I$(CRYPTDIR) -I$(CRYPTDIR)/Include \
		  $(EFI_INCLUDES) \
		  -isystem $(TOPDIR)/include/system \
		  -isystem $(shell $(CC) -print-file-name=include)

WARNFLAGS	+= -Wno-unused-parameter \
		   -Wno-unused-but-set-variable

CFLAGS		= $(FEATUREFLAGS) \
		  $(OPTIMIZATIONS) \
		  $(WARNFLAGS) \
		  $(WERRFLAGS) \
		  $(INCLUDES) \
		  $(DEFINES)

CLANG_BUGS	= $(if $(findstring gcc,$(CC)),-maccumulate-outgoing-args,)

ifeq ($(ARCH),x86_64)
FEATUREFLAGS	+= -m64 -mno-mmx -mno-sse -mno-red-zone $(CLANG_BUGS)
DEFINES		+= -DMDE_CPU_X64
endif
ifeq ($(ARCH),ia32)
FEATUREFLAGS	+= -m32 -mno-mmx -mno-sse -mno-red-zone $(CLANG_BUGS)
DEFINES		+= -DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
DEFINES		+= -DMDE_CPU_AARCH64
endif
ifeq ($(ARCH),arm)
DEFINES		+= -DMDE_CPU_ARM
endif

LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4Null.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hash/CryptSha512.o \
		    Hmac/CryptHmacMd5Null.o \
		    Hmac/CryptHmacSha1Null.o \
		    Hmac/CryptHmacSha256Null.o \
		    Cipher/CryptAesNull.o \
		    Cipher/CryptTdesNull.o \
		    Cipher/CryptArc4Null.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsaBasic.o \
		    Pk/CryptRsaExtNull.o \
		    Pk/CryptPkcs7SignNull.o \
		    Pk/CryptPkcs7Verify.o \
		    Pk/CryptDhNull.o \
		    Pk/CryptTs.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPemNull.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== gnu-efi/Makefile ===
#
#  Copyright (C) 1999-2007 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

VERSION = 3.0.12

MKFILE_PATH := $(abspath $(lastword $(MAKEFILE_LIST)))
SRCDIR = $(dir $(MKFILE_PATH))

VPATH = $(SRCDIR)

include $(SRCDIR)/Make.defaults

SUBDIRS = lib gnuefi inc apps
gnuefi: lib

all:	check_gcc $(SUBDIRS)

mkvars:
	@echo AR=$(AR)
	@echo ARCH=$(ARCH)
	@echo ARCH3264=$(ARCH3264)
	@echo AS=$(AS)
	@echo ASFLAGS=$(ASFLAGS)
	@echo CC=$(CC)
	@echo CFLAGS=$(CFLAGS)
	@echo CPPFLAGS=$(CPPFLAGS)
	@echo GCCMINOR=$(GCCMINOR)
	@echo GCCNEWENOUGH=$(GCCNEWENOUGH)
	@echo GCCVERSION=$(GCCVERSION)
	@echo HOSTARCH=$(HOSTARCH)
	@echo INCDIR=$(INCDIR)
	@echo INSTALL=$(INSTALL)
	@echo INSTALLROOT=$(INSTALLROOT)
	@echo LD=$(LD)
	@echo LDFLAGS=$(LDFLAGS)
	@echo LIBDIR=$(LIBDIR)
	@echo OBJCOPY=$(OBJCOPY)
	@echo OS=$(OS)
	@echo PREFIX=$(PREFIX)
	@echo RANLIB=$(RANLIB)
	@echo SRCDIR=$(SRCDIR)
	@echo TOPDIR=$(TOPDIR)

$(SUBDIRS):
	mkdir -p $(OBJDIR)/$@
	$(MAKE) -C $(OBJDIR)/$@ -f $(SRCDIR)/$@/Makefile SRCDIR=$(SRCDIR)/$@ ARCH=$(ARCH)

clean:
	@rm -vrf *~ $(foreach x,$(ARCHES),$(x)/)
	@set -e ; for d in $(SUBDIRS); do \
		if [ -d $(OBJDIR)/$$d ]; then \
			$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d clean; \
		fi; \
	done

install:
	@set -e ; for d in $(SUBDIRS); do \
		mkdir -p $(OBJDIR)/$$d; \
		$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d install; done

.PHONY:	$(SUBDIRS) clean depend

#
# on both platforms you must use gcc 3.0 or higher 
#
check_gcc:
ifeq ($(GCC_VERSION),2)
	@echo "you need to use a version of gcc >= 3.0, you are using `$(CC) --version`"
	@exit 1
endif

include $(SRCDIR)/Make.rules

test-archive:
	@rm -rf /tmp/gnu-efi-$(VERSION) /tmp/gnu-efi-$(VERSION)-tmp
	@mkdir -p /tmp/gnu-efi-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/gnu-efi-$(VERSION)-tmp/ /tmp/gnu-efi-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/gnu-efi-$(VERSION).tar.bz2 gnu-efi-$(VERSION)
	@rm -rf /tmp/gnu-efi-$(VERSION)
	@echo "The archive is in gnu-efi-$(VERSION).tar.bz2"

tag:
	git tag $(VERSION) refs/heads/master

archive: tag
	@rm -rf /tmp/gnu-efi-$(VERSION) /tmp/gnu-efi-$(VERSION)-tmp
	@mkdir -p /tmp/gnu-efi-$(VERSION)-tmp
	@git archive --format=tar $(VERSION) | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/gnu-efi-$(VERSION)-tmp/ /tmp/gnu-efi-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/gnu-efi-$(VERSION).tar.bz2 gnu-efi-$(VERSION)
	@rm -rf /tmp/gnu-efi-$(VERSION)
	@echo "The archive is in gnu-efi-$(VERSION).tar.bz2"

=== Cryptlib/OpenSSL/Makefile ===
ifneq ($(CCACHE_DISABLE),)
export CCACHE_DISABLE
endif

CRYPTDIR	= $(TOPDIR)/Cryptlib
OSSLDIR		= $(TOPDIR)/Cryptlib/OpenSSL

DEFINES		= -DL_ENDIAN \
		  -D_CRT_SECURE_NO_DEPRECATE \
		  -D_CRT_NONSTDC_NO_DEPRECATE \
		  -DOPENSSL_SMALL_FOOTPRINT \
		  -DPEDANTIC

INCLUDES	= -I$(OSSLDIR) -I$(CRYPTDIR) -I$(OSSLDIR)/Include/ \
		  -I$(OSSLDIR)/crypto -I$(CRYPTDIR)/Include $(EFI_INCLUDES) \
		  -I$(OSSLDIR)/crypto/asn1 -I$(OSSLDIR)/crypto/evp \
		  -I$(OSSLDIR)/crypto/modes -I$(OSSLDIR)/crypto/include \
		  -isystem $(TOPDIR)/include/system \
		  -isystem $(shell $(CC) -print-file-name=include)

FEATUREFLAGS	+= -nostdinc

WARNFLAGS	+= -Wno-empty-body \
		   -Wno-implicit-fallthrough \
		   $(if $(findstring gcc,$(CC)),-Wno-old-style-declaration) \
		   -Wno-unused-but-set-variable \
		   -Wno-unused-parameter

CFLAGS		= $(FEATUREFLAGS) \
		  $(OPTIMIZATIONS) \
		  $(WARNFLAGS) \
		  $(WERRFLAGS) \
		  $(INCLUDES) \
		  $(DEFINES)

CLANG_BUGS	= $(if $(findstring gcc,$(CC)),-maccumulate-outgoing-args,)

ifeq ($(ARCH),x86_64)
FEATUREFLAGS	+= -m64 -mno-mmx -mno-sse -mno-red-zone $(CLANG_BUGS)
DEFINES		+= -DMDE_CPU_X64
endif
ifeq ($(ARCH),ia32)
FEATUREFLAGS	+= -m32 -mno-mmx -mno-sse -mno-red-zone -nostdinc $(CLANG_BUGS)
DEFINES		+= -DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
DEFINES		+= -DMDE_CPU_AARCH64
endif
ifeq ($(ARCH),arm)
DEFINES		+= -DMDE_CPU_ARM
endif

LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libopenssl.a
OBJS		= crypto/cryptlib.o \
		  crypto/mem.o \
		  crypto/mem_clr.o \
		  crypto/mem_dbg.o \
		  crypto/cversion.o \
		  crypto/ex_data.o \
		  crypto/cpt_err.o \
		  crypto/ebcdic.o \
		  crypto/uid.o \
		  crypto/o_time.o \
		  crypto/o_str.o \
		  crypto/o_dir.o \
		  crypto/o_fips.o \
		  crypto/o_init.o \
		  crypto/fips_ers.o \
		  crypto/md5/md5_dgst.o \
		  crypto/md5/md5_one.o \
		  crypto/sha/sha_dgst.o \
		  crypto/sha/sha1dgst.o \
		  crypto/sha/sha_one.o \
		  crypto/sha/sha1_one.o \
		  crypto/sha/sha256.o \
		  crypto/sha/sha512.o \
		  crypto/hmac/hmac.o \
		  crypto/hmac/hm_ameth.o \
		  crypto/hmac/hm_pmeth.o \
		  crypto/rc4/rc4_enc.o \
		  crypto/rc4/rc4_skey.o \
		  crypto/rc4/rc4_utl.o \
		  crypto/aes/aes_misc.o \
		  crypto/aes/aes_ecb.o \
		  crypto/aes/aes_cfb.o \
		  crypto/aes/aes_ofb.o \
		  crypto/aes/aes_ctr.o \
		  crypto/aes/aes_ige.o \
		  crypto/aes/aes_wrap.o \
		  crypto/aes/aes_core.o \
		  crypto/aes/aes_cbc.o \
		  crypto/modes/cbc128.o \
		  crypto/modes/ctr128.o \
		  crypto/modes/cts128.o \
		  crypto/modes/cfb128.o \
		  crypto/modes/ofb128.o \
		  crypto/modes/gcm128.o \
		  crypto/modes/ccm128.o \
		  crypto/modes/xts128.o \
		  crypto/modes/wrap128.o \
		  crypto/bn/bn_add.o \
		  crypto/bn/bn_div.o \
		  crypto/bn/bn_exp.o \
		  crypto/bn/bn_lib.o \
		  crypto/bn/bn_ctx.o \
		  crypto/bn/bn_mul.o \
		  crypto/bn/bn_mod.o \
		  crypto/bn/bn_print.o \
		  crypto/bn/bn_rand.o \
		  crypto/bn/bn_shift.o \
		  crypto/bn/bn_word.o \
		  crypto/bn/bn_blind.o \
		  crypto/bn/bn_kron.o \
		  crypto/bn/bn_sqrt.o \
		  crypto/bn/bn_gcd.o \
		  crypto/bn/bn_prime.o \
		  crypto/bn/bn_err.o \
		  crypto/bn/bn_sqr.o \
		  crypto/bn/bn_asm.o \
		  crypto/bn/bn_recp.o \
		  crypto/bn/bn_mont.o \
		  crypto/bn/bn_mpi.o \
		  crypto/bn/bn_exp2.o \
		  crypto/bn/bn_gf2m.o \
		  crypto/bn/bn_nist.o \
		  crypto/bn/bn_depr.o \
		  crypto/bn/bn_x931p.o \
		  crypto/bn/bn_const.o \
		  crypto/rsa/rsa_eay.o \
		  crypto/rsa/rsa_gen.o \
		  crypto/rsa/rsa_lib.o \
		  crypto/rsa/rsa_sign.o \
		  crypto/rsa/rsa_saos.o \
		  crypto/rsa/rsa_err.o \
		  crypto/rsa/rsa_pk1.o \
		  crypto/rsa/rsa_ssl.o \
		  crypto/rsa/rsa_none.o \
		  crypto/rsa/rsa_oaep.o \
		  crypto/rsa/rsa_chk.o \
		  crypto/rsa/rsa_null.o \
		  crypto/rsa/rsa_pss.o \
		  crypto/rsa/rsa_x931.o \
		  crypto/rsa/rsa_asn1.o \
		  crypto/rsa/rsa_depr.o \
		  crypto/rsa/rsa_ameth.o \
		  crypto/rsa/rsa_prn.o \
		  crypto/rsa/rsa_pmeth.o \
		  crypto/rsa/rsa_crpt.o \
		  crypto/dso/dso_dl.o \
		  crypto/dso/dso_dlfcn.o \
		  crypto/dso/dso_err.o \
		  crypto/dso/dso_lib.o \
		  crypto/dso/dso_null.o \
		  crypto/dso/dso_openssl.o \
		  crypto/dso/dso_win32.o \
		  crypto/dso/dso_vms.o \
		  crypto/dso/dso_beos.o \
		  crypto/dh/dh_asn1.o \
		  crypto/dh/dh_gen.o \
		  crypto/dh/dh_key.o \
		  crypto/dh/dh_lib.o \
		  crypto/dh/dh_check.o \
		  crypto/dh/dh_err.o \
		  crypto/dh/dh_depr.o \
		  crypto/dh/dh_ameth.o \
		  crypto/dh/dh_pmeth.o \
		  crypto/dh/dh_prn.o \
		  crypto/dh/dh_rfc5114.o \
		  crypto/buffer/buffer.o \
		  crypto/buffer/buf_str.o \
		  crypto/buffer/buf_err.o \
		  crypto/bio/bio_lib.o \
		  crypto/bio/bio_cb.o \
		  crypto/bio/bio_err.o \
		  crypto/bio/bss_mem.o \
		  crypto/bio/bss_null.o \
		  crypto/bio/bss_fd.o \
		  crypto/bio/bss_file.o \
		  crypto/bio/bss_sock.o \
		  crypto/bio/bss_conn.o \
		  crypto/bio/bf_null.o \
		  crypto/bio/bf_buff.o \
		  crypto/bio/b_dump.o \
		  crypto/bio/b_print.o \
		  crypto/bio/b_sock.o \
		  crypto/bio/bss_acpt.o \
		  crypto/bio/bf_nbio.o \
		  crypto/bio/bss_log.o \
		  crypto/bio/bss_bio.o \
		  crypto/bio/bss_dgram.o \
		  crypto/stack/stack.o \
		  crypto/lhash/lhash.o \
		  crypto/lhash/lh_stats.o \
		  crypto/rand/md_rand.o \
		  crypto/rand/randfile.o \
		  crypto/rand/rand_lib.o \
		  crypto/rand/rand_err.o \
		  crypto/rand/rand_unix.o \
		  crypto/err/err.o \
		  crypto/err/err_all.o \
		  crypto/err/err_prn.o \
		  crypto/objects/o_names.o \
		  crypto/objects/obj_dat.o \
		  crypto/objects/obj_lib.o \
		  crypto/objects/obj_err.o \
		  crypto/objects/obj_xref.o \
		  crypto/evp/encode.o \
		  crypto/evp/digest.o \
		  crypto/evp/evp_enc.o \
		  crypto/evp/evp_key.o \
		  crypto/evp/evp_acnf.o \
		  crypto/evp/evp_cnf.o \
		  crypto/evp/e_des.o \
		  crypto/evp/e_bf.o \
		  crypto/evp/e_idea.o \
		  crypto/evp/e_des3.o \
		  crypto/evp/e_camellia.o \
		  crypto/evp/e_rc4.o \
		  crypto/evp/e_aes.o \
		  crypto/evp/names.o \
		  crypto/evp/e_seed.o \
		  crypto/evp/e_xcbc_d.o \
		  crypto/evp/e_rc2.o \
		  crypto/evp/e_cast.o \
		  crypto/evp/e_rc5.o \
		  crypto/evp/m_null.o \
		  crypto/evp/m_md2.o \
		  crypto/evp/m_md4.o \
		  crypto/evp/m_md5.o \
		  crypto/evp/m_sha.o \
		  crypto/evp/m_sha1.o \
		  crypto/evp/m_wp.o \
		  crypto/evp/m_dss.o \
		  crypto/evp/m_dss1.o \
		  crypto/evp/m_mdc2.o \
		  crypto/evp/m_ripemd.o \
		  crypto/evp/m_ecdsa.o \
		  crypto/evp/p_open.o \
		  crypto/evp/p_seal.o \
		  crypto/evp/p_sign.o \
		  crypto/evp/p_verify.o \
		  crypto/evp/p_lib.o \
		  crypto/evp/p_enc.o \
		  crypto/evp/p_dec.o \
		  crypto/evp/bio_md.o \
		  crypto/evp/bio_b64.o \
		  crypto/evp/bio_enc.o \
		  crypto/evp/evp_err.o \
		  crypto/evp/e_null.o \
		  crypto/evp/c_all.o \
		  crypto/evp/c_allc.o \
		  crypto/evp/c_alld.o \
		  crypto/evp/evp_lib.o \
		  crypto/evp/bio_ok.o \
		  crypto/evp/evp_pkey.o \
		  crypto/evp/evp_pbe.o \
		  crypto/evp/p5_crpt.o \
		  crypto/evp/p5_crpt2.o \
		  crypto/evp/e_old.o \
		  crypto/evp/pmeth_lib.o \
		  crypto/evp/pmeth_fn.o \
		  crypto/evp/pmeth_gn.o \
		  crypto/evp/m_sigver.o \
		  crypto/evp/e_aes_cbc_hmac_sha1.o \
		  crypto/evp/e_aes_cbc_hmac_sha256.o \
		  crypto/evp/e_rc4_hmac_md5.o \
		  crypto/asn1/a_object.o \
		  crypto/asn1/a_bitstr.o \
		  crypto/asn1/a_utctm.o \
		  crypto/asn1/a_gentm.o \
		  crypto/asn1/a_time.o \
		  crypto/asn1/a_int.o \
		  crypto/asn1/a_octet.o \
		  crypto/asn1/a_print.o \
		  crypto/asn1/a_type.o \
		  crypto/asn1/a_set.o \
		  crypto/asn1/a_dup.o \
		  crypto/asn1/a_d2i_fp.o \
		  crypto/asn1/a_i2d_fp.o \
		  crypto/asn1/a_enum.o \
		  crypto/asn1/a_utf8.o \
		  crypto/asn1/a_sign.o \
		  crypto/asn1/a_digest.o \
		  crypto/asn1/a_verify.o \
		  crypto/asn1/a_mbstr.o \
		  crypto/asn1/a_strex.o \
		  crypto/asn1/x_algor.o \
		  crypto/asn1/x_val.o \
		  crypto/asn1/x_pubkey.o \
		  crypto/asn1/x_sig.o \
		  crypto/asn1/x_req.o \
		  crypto/asn1/x_attrib.o \
		  crypto/asn1/x_bignum.o \
		  crypto/asn1/x_long.o \
		  crypto/asn1/x_name.o \
		  crypto/asn1/x_x509.o \
		  crypto/asn1/x_x509a.o \
		  crypto/asn1/x_crl.o \
		  crypto/asn1/x_info.o \
		  crypto/asn1/x_spki.o \
		  crypto/asn1/nsseq.o \
		  crypto/asn1/x_nx509.o \
		  crypto/asn1/d2i_pu.o \
		  crypto/asn1/d2i_pr.o \
		  crypto/asn1/i2d_pu.o \
		  crypto/asn1/i2d_pr.o \
		  crypto/asn1/t_req.o \
		  crypto/asn1/t_x509.o \
		  crypto/asn1/t_x509a.o \
		  crypto/asn1/t_crl.o \
		  crypto/asn1/t_pkey.o \
		  crypto/asn1/t_spki.o \
		  crypto/asn1/t_bitst.o \
		  crypto/asn1/tasn_new.o \
		  crypto/asn1/tasn_fre.o \
		  crypto/asn1/tasn_enc.o \
		  crypto/asn1/tasn_dec.o \
		  crypto/asn1/tasn_utl.o \
		  crypto/asn1/tasn_typ.o \
		  crypto/asn1/tasn_prn.o \
		  crypto/asn1/ameth_lib.o \
		  crypto/asn1/f_int.o \
		  crypto/asn1/f_string.o \
		  crypto/asn1/n_pkey.o \
		  crypto/asn1/f_enum.o \
		  crypto/asn1/x_pkey.o \
		  crypto/asn1/a_bool.o \
		  crypto/asn1/x_exten.o \
		  crypto/asn1/bio_asn1.o \
		  crypto/asn1/bio_ndef.o \
		  crypto/asn1/asn_mime.o \
		  crypto/asn1/asn1_gen.o \
		  crypto/asn1/asn1_par.o \
		  crypto/asn1/asn1_lib.o \
		  crypto/asn1/asn1_err.o \
		  crypto/asn1/a_bytes.o \
		  crypto/asn1/a_strnid.o \
		  crypto/asn1/evp_asn1.o \
		  crypto/asn1/asn_pack.o \
		  crypto/asn1/p5_pbe.o \
		  crypto/asn1/p5_pbev2.o \
		  crypto/asn1/p8_pkey.o \
		  crypto/asn1/asn_moid.o \
		  crypto/pem/pem_sign.o \
		  crypto/pem/pem_seal.o \
		  crypto/pem/pem_info.o \
		  crypto/pem/pem_lib.o \
		  crypto/pem/pem_all.o \
		  crypto/pem/pem_err.o \
		  crypto/pem/pem_x509.o \
		  crypto/pem/pem_xaux.o \
		  crypto/pem/pem_oth.o \
		  crypto/pem/pem_pk8.o \
		  crypto/pem/pem_pkey.o \
		  crypto/pem/pvkfmt.o \
		  crypto/x509/x509_def.o \
		  crypto/x509/x509_d2.o \
		  crypto/x509/x509_r2x.o \
		  crypto/x509/x509_cmp.o \
		  crypto/x509/x509_obj.o \
		  crypto/x509/x509_req.o \
		  crypto/x509/x509spki.o \
		  crypto/x509/x509_vfy.o \
		  crypto/x509/x509_set.o \
		  crypto/x509/x509cset.o \
		  crypto/x509/x509rset.o \
		  crypto/x509/x509_err.o \
		  crypto/x509/x509name.o \
		  crypto/x509/x509_v3.o \
		  crypto/x509/x509_ext.o \
		  crypto/x509/x509_att.o \
		  crypto/x509/x509type.o \
		  crypto/x509/x509_lu.o \
		  crypto/x509/x_all.o \
		  crypto/x509/x509_txt.o \
		  crypto/x509/x509_trs.o \
		  crypto/x509/x509_vpm.o \
		  crypto/x509v3/v3_bcons.o \
		  crypto/x509v3/v3_bitst.o \
		  crypto/x509v3/v3_conf.o \
		  crypto/x509v3/v3_extku.o \
		  crypto/x509v3/v3_ia5.o \
		  crypto/x509v3/v3_lib.o \
		  crypto/x509v3/v3_prn.o \
		  crypto/x509v3/v3_utl.o \
		  crypto/x509v3/v3err.o \
		  crypto/x509v3/v3_genn.o \
		  crypto/x509v3/v3_alt.o \
		  crypto/x509v3/v3_skey.o \
		  crypto/x509v3/v3_akey.o \
		  crypto/x509v3/v3_pku.o \
		  crypto/x509v3/v3_int.o \
		  crypto/x509v3/v3_enum.o \
		  crypto/x509v3/v3_sxnet.o \
		  crypto/x509v3/v3_cpols.o \
		  crypto/x509v3/v3_crld.o \
		  crypto/x509v3/v3_purp.o \
		  crypto/x509v3/v3_info.o \
		  crypto/x509v3/v3_ocsp.o \
		  crypto/x509v3/v3_akeya.o \
		  crypto/x509v3/v3_pmaps.o \
		  crypto/x509v3/v3_pcons.o \
		  crypto/x509v3/v3_ncons.o \
		  crypto/x509v3/v3_pcia.o \
		  crypto/x509v3/v3_pci.o \
		  crypto/x509v3/pcy_cache.o \
		  crypto/x509v3/pcy_node.o \
		  crypto/x509v3/pcy_data.o \
		  crypto/x509v3/pcy_map.o \
		  crypto/x509v3/pcy_tree.o \
		  crypto/x509v3/pcy_lib.o \
		  crypto/x509v3/v3_asid.o \
		  crypto/x509v3/v3_addr.o \
		  crypto/conf/conf_err.o \
		  crypto/conf/conf_lib.o \
		  crypto/conf/conf_api.o \
		  crypto/conf/conf_def.o \
		  crypto/conf/conf_mod.o \
		  crypto/conf/conf_mall.o \
		  crypto/conf/conf_sap.o \
		  crypto/txt_db/txt_db.o \
		  crypto/pkcs7/pk7_asn1.o \
		  crypto/pkcs7/pk7_lib.o \
		  crypto/pkcs7/pkcs7err.o \
		  crypto/pkcs7/pk7_doit.o \
		  crypto/pkcs7/pk7_smime.o \
		  crypto/pkcs7/pk7_attr.o \
		  crypto/pkcs7/pk7_mime.o \
		  crypto/pkcs7/bio_pk7.o \
		  crypto/pkcs12/p12_add.o \
		  crypto/pkcs12/p12_asn.o \
		  crypto/pkcs12/p12_attr.o \
		  crypto/pkcs12/p12_crpt.o \
		  crypto/pkcs12/p12_crt.o \
		  crypto/pkcs12/p12_decr.o \

=== gnu-efi/gnuefi/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)
TOPDIR = $(SRCDIR)/..

include $(SRCDIR)/../Make.defaults

FILES	= reloc_$(ARCH)  

OBJS	= $(FILES:%=%.o)

# on aarch64, avoid jump tables before all relocations have been processed
reloc_aarch64.o: CFLAGS += -fno-jump-tables

TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a

all:	$(TARGETS)

libgnuefi.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $^


clean:
	@rm -vf $(TARGETS) *~ *.o $(OBJS)

install:
	mkdir -p $(INSTALLROOT)$(LIBDIR)
	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)$(LIBDIR)
ifneq (,$(findstring FreeBSD,$(OS)))
 ifeq ($(ARCH),x86_64)
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)$(LIBDIR)
 else
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
 endif
else
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
endif

include $(SRCDIR)/../Make.rules

=== debian/changelog ===
shim (15.8-1~deb12u1) bookworm; urgency=medium

  [ Steve McIntyre ]
  * Cope with changes in pesign packaging.
  * New upstream release fixing more bugs
  * Remove all our previous patches, no longer needed:
    + Make-sbat_var.S-parse-right-with-buggy-gcc-binutils.patch (now
      upstream)
    + Enable-NX.patch (we don't want NX just yet until the whole boot
      stack is NX-capable)
    + block-grub-sbat3-debian.patch (not needed now upstream grub SBAT
      is 4)
  * Cherry-pick 2 new patches from upstream for grub revocations:
    + 0001-sbat-Add-grub.peimage-2-to-latest-CVE-2024-2312.patch
    + 0002-sbat-Also-bump-latest-for-grub-4-and-to-todays-date.patch
  * Log if the build is nx-compatible or not
  * Force shim to use the latest revocations by default to block some
    older grub / peimage issues. This is:
    "shim,4\ngrub,4\ngrub.peimage,2\n"
  * Install a copy of the Debian CA certificate into /usr/share/shim.
    Closes: #1069054
  * Clean up better after build. Closes: #1046268

  [ Bastien Roucariès ]
  * Port autopkgtest from ubuntu
  * Import MR-12: "shim-unsigned:amd64 cannot be installed alongside
    shim-unsigned:i386", thanks to adrian15 adrian15 (Closes: #936009).
  * Fix debian/watch and check signature

 -- Steve McIntyre <93sam@debian.org>  Sat, 04 May 2024 21:28:21 +0100

=== debian/control ===
Source: shim
Section: admin
Priority: optional
Maintainer: Debian EFI team <debian-efi@lists.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 12),
	       gnu-efi (>= 3.0u),
	       sbsigntool,
	       openssl,
	       libelf-dev,
	       gcc-12,
	       dos2unix,
	       pesign (>= 0.112-5),
	       efivar,
	       xxd,
	       libefivar-dev
Vcs-Browser: https://salsa.debian.org/efi-team/shim
Vcs-Git: https://salsa.debian.org/efi-team/shim.git

Package: shim-unsigned
Architecture: amd64 arm64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: shim (<< 15+1533136590.3beb971-3~),
Replaces: shim (<< 15+1533136590.3beb971-3~),
Multi-Arch: same
Description: boot loader to chain-load signed boot loaders under Secure Boot
 This package provides a minimalist boot loader which allows verifying
 signatures of other UEFI binaries against either the Secure Boot DB/DBX or
 against a built-in signature database.  Its purpose is to allow a small,
 infrequently-changing binary to be signed by the UEFI CA, while allowing
 an OS distributor to revision their main bootloader independently of the CA.

Package: shim-helpers-amd64-signed-template
Architecture: amd64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-amd64-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-i386-signed-template
Architecture: i386
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-i386-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-arm64-signed-template
Architecture: arm64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-arm64-signed.
 This is only needed for Secure Boot signing.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Other vendors, add your certs here.  No sense in using
# dpkg-vendor --derives-from, because only Canonical-generated binaries will
# be signed with this key; so if you are building your own shim binary you
# should be building the other binaries also.
ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
	cert=debian/canonical-uefi-ca.der
	distributor=ubuntu
COMMON_OPTIONS ?= ENABLE_SHIM_CERT=1 ENABLE_SBSIGN=1
else
	cert=debian/debian-uefi-ca.der
	distributor=debian
endif

deb_version             := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version        := $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
plain_upstream_version  := $(shell echo $(upstream_version) | sed -e "s/+dfsg.*//")

DBX_LIST = dbx.esl
DBX_HASHES = debian/$(distributor)-dbx.hashes
SBAT_IN = debian/sbat.$(distributor).csv.in
SBAT_DATA = data/sbat.$(distributor).csv

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),amd64)
export EFI_ARCH := x64
endif
ifeq ($(DEB_HOST_ARCH),arm64)
export EFI_ARCH := aa64
endif
ifeq ($(DEB_HOST_ARCH),i386)
export EFI_ARCH := ia32
endif

COMMON_OPTIONS += \
	RELEASE=$(plain_upstream_version) \
	COMMIT_ID=657b2483ca6e9fcf2ad8ac7ee577ff546d24c3aa \
	MAKELEVEL=0 \
	ENABLE_HTTPBOOT=true \
	VENDOR_CERT_FILE=$(cert) \
	VENDOR_DBX_FILE=$(DBX_LIST) \
	EFIDIR=$(distributor) \
	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
	CC=$(DEB_HOST_GNU_TYPE)-gcc-12 \
	$(NULL)

# Force shim to use the latest revocations by default to block some
# older grub / peimage issues. This is:
# "shim,4\ngrub,4\ngrub.peimage,2\n"
COMMON_OPTIONS += SBAT_AUTOMATIC_DATE=2024010900

$(DBX_LIST): $(DBX_HASHES)
	./debian/generate_dbx_list $(EFI_ARCH) $< $@

$(SBAT_DATA): $(SBAT_IN)
	rm -f $@
	set -e; \
	sed -e "s/@DEB_VERSION@/$(deb_version)/g" \
		-e "s/@UPSTREAM_VERSION@/$(plain_upstream_version)/g" \
		< $(SBAT_IN) > $(SBAT_DATA)
	# If we have an empty $(SBAT_DATA), delete
	if [ ! -s $(SBAT_DATA) ]; then rm -f $(SBAT_DATA); fi

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean -- MAKELEVEL=0
	rm -f $(DBX_LIST) $(SBAT_DATA) sbat.*.csv BOOT*.CSV
	rm -f test-csv test-sbat test-str test-load-options
	rm -f test-mock-variables test-mok-mirror test-pe-relocate test-pe-util

override_dh_auto_build: $(DBX_LIST) $(SBAT_DATA)
	dh_auto_build -- INSTALL=install $(COMMON_OPTIONS)

override_dh_auto_test: $(DBX_LIST) $(SBAT_DATA)
	dh_auto_test -- INSTALL=install $(COMMON_OPTIONS)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -- INSTALL=install $(COMMON_OPTIONS)
	# Remove the copy of the source that's installed - we have git
	# already...
	rm -rf debian/tmp/usr
	# And remove the extra removable-media copy of shim too, it's
	# not needed for our build and causes debhelper to complain
	rm -f debian/tmp/boot/efi/EFI/BOOT/BOOT*.EFI

	install -m 644 $(cert) debian/shim-unsigned/usr/share/shim

	# Generate the template packages that we'll use for SB signing later
	./debian/signing-template.generate

	# Log some useful things about the build here
	./debian/check_nx shim*.efi
	sha256sum *.efi

generate-gnu-efi:
	git -C gnu-efi archive --prefix=gnu-efi/ HEAD | xz -9 \
		> ../shim_$(plain_upstream_version).orig-gnu-efi.tar.xz

=== debian/tests/control ===
Test-Command: python3 debian/tests/01_sanity_tests.py
Depends: @,
  qemu-system-arm [arm64],
  qemu-system-x86 [amd64],
  lsb-release,
  python3,
  wget,
  openssl,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=sanity

Test-Command: python3 debian/tests/05_signature_tests.py
Depends: @,
  sbsigntool,
  grub-efi-arm64-signed [arm64],
  grub-efi-amd64-signed [amd64],
  shim-signed [amd64],
  shim-signed [arm64],
  lsb-release,
  python3,
  wget,
  openssl,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=signatures

Test-Command: python3 debian/tests/10_uefi_boot_tests.py
Depends: @,
  autopkgtest,
  genisoimage,
  qemu-utils,
  sbsigntool,
  qemu-system-arm [arm64],
  qemu-system-x86 [amd64],
  ovmf [amd64],
  qemu-efi-aarch64 [arm64],
  grub-efi-arm64-signed [arm64],
  grub-efi-amd64-signed [amd64],
  shim-signed [amd64],
  shim-signed [arm64],
  lsb-release,
  python3,
  wget,
  openssl,
  ca-certificates,
  distro-info,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=boot-test

## shim 15.8-1~deb11u1+11.0trisquel0

=== debian/changelog ===
shim (15.8-1~deb11u1+11.0trisquel0) aramo; urgency=medium

  * Rebuild to get unsigned binary as dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 31 Aug 2024 18:42:42 +0000

shim (15.8-1~deb11u1) bullseye; urgency=medium

  * New upstream release fixing more bugs
  * Remove all our previous patches, no longer needed:
    + Make-sbat_var.S-parse-right-with-buggy-gcc-binutils.patch (now
      upstream)
    + Enable-NX.patch (we don't want NX just yet until the whole boot
      stack is NX-capable)
    + block-grub-sbat3-debian.patch (not needed now upstream grub SBAT
      is 4)
  * Cherry-pick 2 new patches from upstream for grub revocations:
    + 0001-sbat-Add-grub.peimage-2-to-latest-CVE-2024-2312.patch
    + 0002-sbat-Also-bump-latest-for-grub-4-and-to-todays-date.patch
  * Log if the build is nx-compatible or not
  * Force shim to use the latest revocations by default to block some
    older grub / peimage issues. This is:
    "shim,4\ngrub,4\ngrub.peimage,2\n"
  * Install a copy of the Debian CA certificate into /usr/share/shim.
    Closes: #1069054
  * Clean up better after build. Closes: #1046268

 -- Steve McIntyre <93sam@debian.org>  Mon, 05 May 2024 11:33:57 +0100

## shim 15.8-1trisquel0

=== debian/changelog ===
shim (15.8-1trisquel0) ecne; urgency=medium

  * Rebuild to get unsigned binary as dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 16 Mar 2025 10:40:37 +0000

shim (15.8-1) unstable; urgency=medium

  [ Steve McIntyre ]
  * Cope with changes in pesign packaging. Closes: #1057606
  * New upstream release fixing more bugs. Closes: #1061519, #1064220
    + CVE-2023-40546 mok: fix LogError() invocation (Closes: #1054210)
    + CVE-2023-40547 - avoid incorrectly trusting HTTP headers
    + CVE-2023-40548 Fix integer overflow on SBAT section size on
      32-bit system
    + CVE-2023-40549 Authenticode: verify that the signature header is
      in bounds.
    + CVE-2023-40550 pe: Fix an out-of-bound read in
      verify_buffer_sbat()
    + CVE-2023-40551: pe-relocate: Fix bounds check for MZ binaries
  * Remove all our previous patches, no longer needed:
    + Make-sbat_var.S-parse-right-with-buggy-gcc-binutils.patch (now
      upstream)
    + Enable-NX.patch (we don't want NX just yet until the whole boot
      stack is NX-capable)
    + block-grub-sbat3-debian.patch (not needed now upstream grub SBAT
      is 4)
  * Cherry-pick 2 new patches from upstream for grub revocations:
    + 0001-sbat-Add-grub.peimage-2-to-latest-CVE-2024-2312.patch
    + 0002-sbat-Also-bump-latest-for-grub-4-and-to-todays-date.patch
  * NOTE: Stop building for i386
    + Debian kernels are no longer signed for i386, it's time to stop
      supporting i386 SB.
  * Log if the build is nx-compatible or not
  * Force shim to use the latest revocations by default to block some
    older grub / peimage issues. This is:
    "shim,4\ngrub,4\ngrub.peimage,2\n"
  * Install a copy of the Debian CA certificate into /usr/share/shim.
    Closes: #1069054
  * Clean up better after build. Closes: #1046268

  [ Bastien Roucariès ]
  * Port autopkgtest from ubuntu
  * Import MR-12: "shim-unsigned:amd64 cannot be installed alongside
    shim-unsigned:i386", thanks to adrian15 adrian15 (Closes: #936009).
  * Fix debian/watch and check signature (Closes: #1043485)

 -- Steve McIntyre <93sam@debian.org>  Sat, 04 May 2024 23:29:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
 Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 12),
@@ -19,7 +19,7 @@
 Vcs-Git: https://salsa.debian.org/efi-team/shim.git
 
 Package: shim-unsigned
-Architecture: amd64 arm64 i386
+Architecture: amd64 arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: shim (<< 15+1533136590.3beb971-3~),
 Replaces: shim (<< 15+1533136590.3beb971-3~),
@@ -38,13 +38,6 @@
  This package contains template files for shim-helpers-amd64-signed.
  This is only needed for Secure Boot signing.
 
-Package: shim-helpers-i386-signed-template
-Architecture: i386
-Depends: ${misc:Depends},
-Description: boot loader to chain-load signed boot loaders (signing template)
- This package contains template files for shim-helpers-i386-signed.
- This is only needed for Secure Boot signing.
-
 Package: shim-helpers-arm64-signed-template
 Architecture: arm64
 Depends: ${misc:Depends},
